

#include "tweak.h"
#include <map>
#include <fstream>
#include <iostream>
#include <list>

#include "math.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>



std::string trimwhite(std::string str) {
	std::string::size_type notwhite = str.find_first_not_of(" \t\r\n");
	str.erase(0,notwhite);
	notwhite = str.find_last_not_of(" \t\r\n");
	str.erase(notwhite+1);
	return str;
} 

std::string next_part(int *p,std::string str,std::string search) {
   std::string s;
   s=str.substr(*p,str.length());
   int np=s.find(search);
    if (np==std::string::npos) { (*p)=-1; return s; }
   s=str.substr(*p,np);
   (*p)+=np+1;
   return s;
}



std::map <std::string,int> ints;
std::map <std::string,float> floats;
std::map <std::string,C3> colors;
std::map <std::string,C3> mc3;
std::map <std::string,C3f> mc3f;

std::string filename="val.txt";


/*std::string Werte::get_value(std::string key) {
	std::map <std::string,std::string>::iterator it;

	it=tab.find(key);

	//if (it==tab.end()) return "";
if (it==tab.end()) {
std::cout << "key: (" << key <<") nicht gefunden. Abbruch." <<std::endl;
exit(1);
}

return (*it).second;
}*/



bool reported_missing=false;
std::list <std::string > missing;

void Tweak::report_missing_key(std::string name) {
		//std::cout << "key: (" << name <<") nicht gefunden. Abbruch." <<std::endl;
	std::list <std::string >::iterator it;
	for (it=missing.begin();it!=missing.end();it++) {
		if ((*it)==name) return;
	}

	missing.insert(missing.end(),name);

	std::ofstream o;
	if (!reported_missing) {
		o.open("missingkey.txt",std::ofstream::out);
	} else {
		o.open("missingkey.txt",std::ofstream::out | std::ofstream::app);
	}

	if (!o) {
		return;
	}
	o << name << std::endl;;

	o.close();
	
	reported_missing=true;
}

int Tweak::i(std::string name) {
	std::map <std::string,int>::iterator it;

	it=ints.find(name);
	if (it==ints.end()) {
		report_missing_key(name);
		return 0;
	}
	return (*it).second;
}
float Tweak::f(std::string name) {
	std::map <std::string,float>::iterator it;

	it=floats.find(name);
	if (it==floats.end()) {
		report_missing_key(name);
		return 0;
	}
	return (*it).second;
}
C3 Tweak::C(std::string name) {
	return color(name);
}
C3 Tweak::color(std::string name) {
	std::map <std::string,C3>::iterator it;

	it=colors.find(name);
	if (it==colors.end()) {
		report_missing_key(name);
		return 0;
	}
	return (*it).second;
}
C3 Tweak::c3(std::string name) {
	std::map <std::string,C3>::iterator it;

	it=mc3.find(name);
	if (it==mc3.end()) {
		report_missing_key(name);
		return 0;
	}
	return (*it).second;
}
C3f Tweak::c3f(std::string name) {
	std::map <std::string,C3f>::iterator it;

	it=mc3f.find(name);
	if (it==mc3f.end()) {
		report_missing_key(name);
		return 0;
	}
	return (*it).second;
}


void Tweak::tick() {
	if (check_file()) {
		read_file();
	}
}

struct stat old;

bool Tweak::check_file() {
	struct stat current;

	lstat(filename.c_str(),&current);

	if (current.st_mtime==old.st_mtime) return false;
	old.st_mtime=current.st_mtime;
	std::cout << "file changed " << current.st_mtime << std::endl;
	
	return true;
}

bool Tweak::read_file() {
	missing.resize(0);
	reported_missing=false;
	floats.erase(floats.begin(),floats.end());
	ints.erase(ints.begin(),ints.end());
	colors.erase(colors.begin(),colors.end());
	mc3.erase(mc3.begin(),mc3.end());
	mc3f.erase(mc3f.begin(),mc3f.end());
	std::string line;
	std::ifstream inf(filename.c_str());
	std::string key,value;
	unsigned int c;
	std::string kat="";

	if (!inf) {
		return false;
	}
	while(!std::getline(inf,line).eof()) {
		/*if (line[line.length()-1]=='\r') {
			line.resize(line.length()-1);
		}*/
		line=trimwhite(line);
		if (line.c_str()[0]=='#') {
			//std::cout << "kommentar uebergangen: " << line << std::endl;
			continue;
		}

		/*if (line.c_str()[0]=='[') {
			kat=line.substr(1,line.length()-2);
			std::cout << "kategorie: " << kat << std::endl;
			continue;
		}*/


		c=line.find("=");
		if (c==std::string::npos) {
			continue;
		}
		//std::cout << "c: " << c << std::endl;
		key=line.substr(0,c);
		value=line.substr(c+1,line.length());

		//std::cout << "inserting: " << kat << " - [" << key << "] (" << value << ")" << std::endl;

		unsigned int pos=key.find_last_of('_');
		//std::cout << "pos: " << pos << std::endl;
		std::string ext(key,pos);
		//std::cout << "ext: " << ext << std::endl;

		if (ext=="_i") {
			ints.insert(ints.end(),std::make_pair(key,atoi(value.c_str())));
			continue;
		}
		if (ext=="_f") {
			//std::cout << "af" << atof(value.c_str()) << std::endl;
			//std::cout << "gf" << f(key) << std::endl;
			floats.insert(floats.end(),std::make_pair(key,atof(value.c_str())));
			//std::cout << "gf" << f(key) << std::endl;
			continue;
		}
		if (ext=="_color") {
			C3 cc;
      	int a=0;
			if (value!="") {
				cc.x=atoi(next_part(&a,value,",").c_str());
				cc.y=atoi(next_part(&a,value,",").c_str());
				cc.z=atoi(next_part(&a,value,",").c_str());
			}

			colors.insert(colors.end(),std::make_pair(key,cc));
		}
		if (ext=="_C3") {
			C3 cc;
      	int a=0;
			if (value!="") {
				cc.x=atoi(next_part(&a,value,",").c_str());
				cc.y=atoi(next_part(&a,value,",").c_str());
				cc.z=atoi(next_part(&a,value,",").c_str());
			}

			mc3.insert(mc3.end(),std::make_pair(key,cc));
		}
		if (ext=="_C3f") {
			C3f ccf;
      	int a=0;
			if (value!="") {
				ccf.x=atof(next_part(&a,value,",").c_str());
				ccf.y=atof(next_part(&a,value,",").c_str());
				ccf.z=atof(next_part(&a,value,",").c_str());
			}

			mc3f.insert(mc3f.end(),std::make_pair(key,ccf));
		}

		/*char ty=key.c_str()[0];
		C3 c;
      int a=0;

		switch (ty) {
			case 'i': 
				ints.insert(ints.end(),std::make_pair(key,atoi(value.c_str())));
				break;
			case 'f': 
				floats.insert(floats.end(),std::make_pair(key,atof(value.c_str())));
				break;
			case 'C': 

				c.x=atoi(next_part(&a,value,",").c_str());
				c.y=atoi(next_part(&a,value,",").c_str());
				c.z=atoi(next_part(&a,value,",").c_str());

				colors.insert(colors.end(),std::make_pair(key,c));
				break;
			default:
				std::cout << "invalid name " << key << std::endl;
				break;
		}*/

		//tab.insert(tab.end(),std::make_pair(kat+key,value));
	}
	return true;
}



